var working = true
//var sql_exporter_tool = ''
var fetch_url = ''
var alive = 0;


function appended_function(f,g){
    if(f)
        f()
    g()
}

function getRequest() {
    var req;
    if(window.XMLHttpRequest) {
        try {
            req = new XMLHttpRequest();
        } catch(e) {
            req = false;
        }
    } else if(window.ActiveXObject) {
        try {
            req = new ActiveXObject("Msxml2.XMLHTTP");
        } catch(e) {
            try {
                req = new ActiveXObject("Microsoft.XMLHTTP");
            } catch(e) {
                req = false;
            }
        }
    }
    return req;
}

download_template = '<li>Download: <a href="'+'sql_exporter_tool'+'/get_tar_gz?xptr_id=${xptr_id}">sql_results.tar.gz</a></li>'

function exporter_start(url,xptr_id){
    var link = document.getElementById(xptr_id+'_start');
    link.style.display = 'none';
    var status = document.getElementById(xptr_id+'_state');
    status.innerHTML = 'starting';
    var req = getRequest();
    if(req) {
        req.onreadystatechange = function (){
            if (req.readyState == 4) {
                if (req.status == 200) {
                    var resultText = req.responseText;
                    if (resultText == 'done'){
                        var ul = document.getElementById(xptr_id);
                        ul.innerHTML = ul.innerHTML + download_template.replace('${xptr_id}',xptr_id);
                    }
                    refresh();
                }
            }
        }
        req.open("GET", url, true);
        req.send(null);
    }else{
        alert('AJAX is not fully supported on this browser.');
    }
    if (!working){
        working = true;
    }
    refresh()
    return false;
}

function init(){
    setTimeout("start_first()",0);
    setTimeout("refresh()", 500);
}

function start_first(){
    var startme = document.getElementById('startme');
    if (startme != null){
        fireEvent(startme,'click');
        var start_link = document.getElementById(startme.getAttribute('name')+'_start');
        if(start_link != null){
            fireEvent(start_link,'click');
        }
    }
}

function refresh(){
    if(alive > 0){
        return;
    }
    alive++;
    if(fetch_url == ''){
        if (sql_exporter_tool == ''){
            fetch_url = window.location.toString().split('?')[0] + '_xml';
        }else{
            fetch_url = sql_exporter_tool + '/results_sql_exporter_xml'
        }
    }
    var req = getRequest();
    if(req) {
        req.onreadystatechange = function (){
            if (req.readyState == 4) {
                if (req.status == 200) {
                    alive--;
                    var resultxml = req.responseXML.getElementsByTagName('results')[0];
                    var aux;
                    working = 'true' == resultxml.getAttribute('working');
                    var xptrs_xml = req.responseXML.getElementsByTagName('xptr')
                    for(var i=0;i<xptrs_xml.length;i++){
                        xptr_id = xptrs_xml[i].getAttribute('id')
                        var att = null;
                        for(var j=0;j<xptrs_xml[i].attributes.length;j++){
                            att = xptrs_xml[i].attributes.item(j)
                            if(att.localName == 'id' || att.localName == 'runnable'){
                                continue;
                            }
                            aux = document.getElementById(xptr_id+'_'+att.localName)
                            if(aux != null){
                                aux.innerHTML = att.nodeValue;
                            }
                        }
                    }
                    if(working){
                        setTimeout("refresh()", 500);
                    }
                }
            }
        }
        req.open("GET", fetch_url, true);
        req.send(null);
    }else {
        alert('AJAX is not fully supported on this browser.');
    }
    return;
}

function fold_unfold(xptr_id){
    var span = document.getElementById('fold_ufold_'+xptr_id);
    var dd = document.getElementById('details_'+xptr_id);
    if(span.innerHTML == '[+]'){
        span.innerHTML = '[-]';
        dd.style.display = 'block';
    }else{
        span.innerHTML = '[+]';
        dd.style.display = 'none';
    }
}

function fireEvent(element,event){
    if (document.createEventObject){
        // dispatch for IE
        var evt = document.createEventObject();
        return element.fireEvent('on'+event,evt)
    }
    else{
        // dispatch for firefox + others
        var evt = document.createEvent("HTMLEvents");
        evt.initEvent(event, true, true ); // event type,bubbling,cancelable
        return !element.dispatchEvent(evt);
    }
}
